package java.lang;

import java.io.ObjectInputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;

public final class StringBuilder extends AbstractStringBuilder implements Serializable, CharSequence
{
    static final long serialVersionUID = 4383685877147921099L;
    
    public StringBuilder() {
        super(16);
    }
    
    public StringBuilder(int n) {
        super(n);
    }
    
    public StringBuilder(String s) {
        super(s.length() + 16);
        this.append(s);
    }
    
    public StringBuilder(CharSequence charSequence) {
        this(charSequence.length() + 16);
        this.append(charSequence);
    }
    
    @Override
    public StringBuilder append(Object o) {
        return this.append(String.valueOf(o));
    }
    
    @Override
    public StringBuilder append(String s) {
        super.append(s);
        return this;
    }
    
    @Override
    public StringBuilder append(StringBuffer sb) {
        super.append(sb);
        return this;
    }
    
    @Override
    public StringBuilder append(CharSequence charSequence) {
        super.append(charSequence);
        return this;
    }
    
    @Override
    public StringBuilder append(CharSequence charSequence, int n, int n2) {
        super.append(charSequence, n, n2);
        return this;
    }
    
    @Override
    public StringBuilder append(char[] array) {
        super.append(array);
        return this;
    }
    
    @Override
    public StringBuilder append(char[] array, int n, int n2) {
        super.append(array, n, n2);
        return this;
    }
    
    @Override
    public StringBuilder append(boolean b) {
        super.append(b);
        return this;
    }
    
    @Override
    public StringBuilder append(char c) {
        super.append(c);
        return this;
    }
    
    @Override
    public StringBuilder append(int n) {
        super.append(n);
        return this;
    }
    
    @Override
    public StringBuilder append(long n) {
        super.append(n);
        return this;
    }
    
    @Override
    public StringBuilder append(float n) {
        super.append(n);
        return this;
    }
    
    @Override
    public StringBuilder append(double n) {
        super.append(n);
        return this;
    }
    
    @Override
    public StringBuilder appendCodePoint(int n) {
        super.appendCodePoint(n);
        return this;
    }
    
    @Override
    public StringBuilder delete(int n, int n2) {
        super.delete(n, n2);
        return this;
    }
    
    @Override
    public StringBuilder deleteCharAt(int n) {
        super.deleteCharAt(n);
        return this;
    }
    
    @Override
    public StringBuilder replace(int n, int n2, String s) {
        super.replace(n, n2, s);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, char[] array, int n2, int n3) {
        super.insert(n, array, n2, n3);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, Object o) {
        super.insert(n, o);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, String s) {
        super.insert(n, s);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, char[] array) {
        super.insert(n, array);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, CharSequence charSequence) {
        super.insert(n, charSequence);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, CharSequence charSequence, int n2, int n3) {
        super.insert(n, charSequence, n2, n3);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, boolean b) {
        super.insert(n, b);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, char c) {
        super.insert(n, c);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, int n2) {
        super.insert(n, n2);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, long n2) {
        super.insert(n, n2);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, float n2) {
        super.insert(n, n2);
        return this;
    }
    
    @Override
    public StringBuilder insert(int n, double n2) {
        super.insert(n, n2);
        return this;
    }
    
    @Override
    public int indexOf(String s) {
        return super.indexOf(s);
    }
    
    @Override
    public int indexOf(String s, int n) {
        return super.indexOf(s, n);
    }
    
    @Override
    public int lastIndexOf(String s) {
        return super.lastIndexOf(s);
    }
    
    @Override
    public int lastIndexOf(String s, int n) {
        return super.lastIndexOf(s, n);
    }
    
    @Override
    public StringBuilder reverse() {
        super.reverse();
        return this;
    }
    
    @Override
    public String toString() {
        return new String(this.value, 0, this.count);
    }
    
    private void writeObject(ObjectOutputStream objectOutputStream) throws IOException {
        objectOutputStream.defaultWriteObject();
        objectOutputStream.writeInt(this.count);
        objectOutputStream.writeObject(this.value);
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException, ClassNotFoundException {
        objectInputStream.defaultReadObject();
        this.count = objectInputStream.readInt();
        this.value = (char[])(char[])objectInputStream.readObject();
    }
}
